/*============================================================================
//	apci32w.c
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//==========================================================================*/
#include <windows.h>
#include <tchar.h>
#include "apci32w.h"	/* apci-P32 */

/*-------------------------------------
// (STATIC)ϐȂ
//-----------------------------------*/
static BOOL Apci32wGetDllExportFunc();
static HMODULE hDLL = NULL;

/* DLL ߰Ċ֐ڽ̊i[ϐ */
static FARPROC pApci32GetVersion = NULL;
static FARPROC pApci32Create = NULL;
static FARPROC pApci32Close = NULL;
static FARPROC pApci32GetResource = NULL;
static FARPROC pApci32InPort = NULL;
static FARPROC pApci32GetLastError = NULL;
static FARPROC pApci32GetSwitchValue = NULL;

/*============================================================================
// 	  apci32.dll۰(۰ގʹװƂ)	
// 	  
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci32wDllOpen()
{
	BOOL	Result = FALSE;
	if (hDLL == NULL){
		hDLL = (HMODULE)LoadLibrary(APCI32_DLL_NAME);
		if (hDLL != NULL){
			Result = Apci32wGetDllExportFunc();
			if (TRUE != Result)
				Apci32wDllClose();	/* DLL֐擾ɎŝDLL۰ */
		}
	}
	return Result;
}
/*============================================================================
// 	  apci32.dll۰(۰ގʹװƂ)
// 	  
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci32wDllClose()
{
	BOOL	Result = FALSE;
	if (hDLL != NULL){
		Result = FreeLibrary(hDLL);
		if (TRUE == Result)
			hDLL = NULL;
	}
	return Result;
}
/*============================================================================
// 	  apci-P32 DLL,޲ײްްޮݔԍ擾
// 	  pdwDllVersion		DLLްޮݔԍi[̈ւ߲
//		  pdwDriverVersion	޲ײްްޮݔԍi[̈ւ߲
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci32wGetVersion(PDWORD pdwDllVersion, PDWORD pdwDriverVersion)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci32GetVersion)(pdwDllVersion, pdwDriverVersion);
	return Result;
}
/*============================================================================
// 	  apci-P32̔Cӂ޲̎gp錾
// 	  pwLogSlot	 gp޲̘_ۯĔԍi[߲
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci32wCreate(PWORD pwLogSlot)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci32Create)(pwLogSlot);
	return Result;
}
/*============================================================================
// 	  apci-P32̔Cӂ޲̎gpJ
// 	  wLogSlot ޲̘_ۯĔԍ
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci32wClose(WORD wLogSlot)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci32Close)(wLogSlot);
	return Result;
}
/*============================================================================
// 	  w޲ؿ擾
// 	  wLogSlot	ؿ擾޲̘_ۯĔԍ
//		  pResInfo	ؿi[\߲̂
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci32wGetResource(WORD wLogSlot, PAPCI32R pResInfo)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci32GetResource)(wLogSlot, pResInfo);
	return Result;
}
/*============================================================================
// 	  Cӂ߰Ăް
// 	  wLogSlot	͂޲̘_ۯĔԍ
//		  dwLogPort	͂_߰
//		  pbInValue ްi[̈ւ߲
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci32wInPort(WORD wLogSlot, DWORD dwLogPort, PBYTE pbInValue)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci32InPort)(wLogSlot, dwLogPort, pbInValue);
	return Result;
}
/*============================================================================
// 	  apci-P32̴װ
// 	  wLogSlot	װ޲̘_ۯĔԍ
// ߂l װ
//==========================================================================*/
DWORD Apci32wGetLastError(WORD wLogSlot)
{
	if (NULL == hDLL)
		return APCI32_ERR_WRAPDLL;
	else
		return (*pApci32GetLastError)(wLogSlot);
}
/*============================================================================
// 	  ۰ذ̒l擾
//    wLogSlot			۰ذ̒l擾޲̘_ۯĔԍ
// 		  pdwSwitchValue	۰ذ̒li[̈ւ߲
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci32wGetSwitchValue(WORD wLogSlot, PDWORD pdwSwitchValue)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci32GetSwitchValue)(wLogSlot, pdwSwitchValue);
	return Result;
}
/*----------------------------------------------------------------------------
// 	  DLL߰Ċ֐ڽ̎擾
// 	  
// ߂l  TRUE
//		  s FALSE
//--------------------------------------------------------------------------*/
static BOOL Apci32wGetDllExportFunc()
{
	/* Apci32GetVersion ̱ڽ擾 */
	pApci32GetVersion = GetProcAddress(hDLL, "Apci32GetVersion");
	if (pApci32GetVersion == NULL)
		return FALSE;

	/* Apci32Create ̱ڽ擾 */
	pApci32Create = GetProcAddress(hDLL, "Apci32Create");
	if (pApci32Create == NULL)
		return FALSE;

	/* Apci32Close ̱ڽ擾 */
	pApci32Close = GetProcAddress(hDLL, "Apci32Close");
	if (pApci32Close == NULL)
		return FALSE;

	/* Apci32GetResource ̱ڽ擾 */
	pApci32GetResource = GetProcAddress(hDLL, "Apci32GetResource");
	if (pApci32GetResource == NULL)
		return FALSE;

	/* Apci32InPort ̱ڽ擾 */
	pApci32InPort = GetProcAddress(hDLL, "Apci32InPort");
	if (pApci32InPort == NULL)
		return FALSE;

	/* Apci32GetLastError ̱ڽ擾 */
	pApci32GetLastError = GetProcAddress(hDLL, "Apci32GetLastError");
	if (pApci32GetLastError == NULL)
		return FALSE;

	/* Apci32GetSwitchValue ̱ڽ擾 */
	pApci32GetSwitchValue = GetProcAddress(hDLL, "Apci32GetSwitchValue");
	if (pApci32GetSwitchValue == NULL)
		return FALSE;

	return TRUE;	/* SĂ DLL ߰Ċ֐ڽ擾 */
}
