/*============================================================================
//	apci32s.c
//
//	apci-P32
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	V1.10 Date 1999/05/31
//
//	̿ɂׯ߰֐̎gpႪLqĂ܂B
//
//==========================================================================*/
#define	STRICT
#include <windows.h>
#include <tchar.h>
#include "apci32w.h"

const TCHAR szTitle[] = _T("Sample");
const TCHAR sz32[]  = _T("apci-P32");

static void ResultMessage(LPCTSTR lpszbuf);
static void ErrorMessage(WORD wLogSlot);

/*============================================================================
//	۸т̊Jn
//===========================================================================*/
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	WORD  wLogSlot;				/* ޲̘_ۯĔԍi[ */
	APCI32RESOURCE Ri;		/* ؿ */
	DWORD dwDLLVer, dwDriverVer;
	DWORD dwSwVal;				/* ۰ذ̒l */
	BYTE  cbDat;
	BOOL  bResult;				/*  */
	TCHAR szBuf[256];

	/*-------------------------------------------------
	// apci32.dll ̎gp錾
	//-----------------------------------------------*/
	if (Apci32wDllOpen() == FALSE){
		ErrorMessage(APCI32_SLOT_AUTO);
		return 1;				/* apci32.dll ۰ނɎs܂ */
	}
	/*-------------------------------------------------
	// ްޮݔԍ\
	// apci-P32 DLL,ײްްޮݔԍ擾
	//-----------------------------------------------*/
	if (Apci32wGetVersion(&dwDLLVer, &dwDriverVer) == FALSE){
		ErrorMessage(APCI32_SLOT_AUTO);
		return 1;
	}
	wsprintf(szBuf, _T("GetVersion\n")
					_T("DLL    Version\t: %08lxh\n")
					_T("Driver Version\t: %08lxh"),
					dwDLLVer,
					dwDriverVer);
	ResultMessage(szBuf);
	/*-------------------------------------------------
	// apci-P32̎gp錾
	//-----------------------------------------------*/
	wLogSlot = APCI32_SLOT_AUTO;			/* gp޲T܂B*/
	bResult = Apci32wCreate(&wLogSlot);	/* ꍇA̎޲̗ϗۯĔԍi[܂B*/
	if (bResult == FALSE){					/* ޲܂B*/
		ErrorMessage(APCI32_SLOT_AUTO);
		return 1;
	}
	wsprintf(szBuf, _T("apci-P32 Created\n\n")
					_T("LogSlot: %2d"),
					 wLogSlot);
	ResultMessage(szBuf);
	/*-------------------------------------------------
	// ؿ۰ذ̒l擾
	//-----------------------------------------------*/
	if (Apci32wGetResource(wLogSlot, &Ri) == FALSE){
		ErrorMessage(wLogSlot);
		return 1;
	}
	if (Apci32wGetSwitchValue(wLogSlot, &dwSwVal) == FALSE){
		ErrorMessage(wLogSlot);
		return 1;
	}
	wsprintf(szBuf, _T("Board Name  \t: %s\n")
					_T("IO Address  \t: %04Xh-%04Xh\n")
					_T("EICR Address\t: %04Xh-%04Xh\n")
					_T("Switch      \t: %02X\n"),
					sz32,
					Ri.dwIOPortBase[1],
					Ri.dwIOPortBase[1] + Ri.dwIOPortLength[1] - 1,
					Ri.dwIOPortBase[0],
					Ri.dwIOPortBase[0] + Ri.dwIOPortLength[0] - 1,
					dwSwVal);
	ResultMessage(szBuf);
	/*-------------------------------------------------
	// Port 1 ްǂݍ
	//-----------------------------------------------*/
	cbDat = (BYTE)0x00;
	if (Apci32wInPort(wLogSlot, APCI32_PORT_1, &cbDat) == FALSE){
		ErrorMessage(wLogSlot);
		return 1;
	}
	wsprintf(szBuf, _T("Port 1 f[^\n")
					_T("Port 1 In Data: %02xh"),
					 cbDat);
	ResultMessage(szBuf);
	/*-------------------------------------------------
	// apci-P32̎gpJ
	//-----------------------------------------------*/
	if (Apci32wClose(wLogSlot) == FALSE){
		ErrorMessage(wLogSlot);
		return 1;
	}
	ResultMessage(_T("apci-P32 Closed"));
	/*-------------------------------------------------
	// apci32.dll ̎gpJ
	//-----------------------------------------------*/
	if (Apci32wDllClose() == FALSE){
		MessageBox(NULL, _T("DLL ̃A[hɎs܂B"), szTitle, MB_OK | MB_ICONSTOP);
		return 1;
	}
	return 0;
}
/*============================================================================
// ʂ\
//==========================================================================*/
static void ResultMessage(LPCTSTR lpszbuf)
{
	MessageBox(NULL, lpszbuf, szTitle, MB_OK | MB_ICONINFORMATION);
}
/*============================================================================
// װүނ\
//==========================================================================*/
static void ErrorMessage(WORD wLogSlot)
{
	DWORD dwRes = Apci32wGetLastError(wLogSlot);
	TCHAR szBuf[50];

	switch (dwRes){
		case APCI32_ERR_SYSTEM:
			wsprintf(szBuf, _T("System error\n\n")
							_T("Error code: %08lxh"),
							GetLastError());
			break;
		case APCI32_ERR_WRAPDLL:
			wsprintf(szBuf, _T("DLL Load error"));
			break;
		default:
			wsprintf(szBuf, _T("apci-P32 error\n\n")
							_T("Error code: %08lxh"),
							dwRes);
			break;
	}
	MessageBox(NULL, szBuf, szTitle, MB_OK | MB_ICONSTOP);
}
